#!/bin/bash

docker_dir="$CUR_DIR/Dockerfiles"
dockerfiles=""
docker_sel=""
docker_sel_dir=""

docker_name="tas_docker"
docker_mysql_port="3306"
docker_tas_port="6500"
docker_tas_debug="6666"
buildDocker=""
runDocker=""
runDocker_mac=""
execDocker=""

function selectDockerfile() {
	getDockerfileList

	if [ "$docker_sel" = "" ]; then
		PS3="# "
		select docker_sel in "${dockerfiles[@]}"; 
		do 
			echo_color "You selected ${docker_sel}"
			break
		done
	fi
	docker_sel_dir="$docker_dir/$docker_sel"
}

function getDockerfileList() {
	execCmd "cd $docker_dir"
	execCmd "dockerfiles=($(ls -d */ | cut -f1 -d'/'))"
	execCmd "cd $$CUR_DIR"
}

function askDockerInfo() {
	if [ "${isFullInstall}" = false ]; then
		echo_line "What name for your docker image? If you want default name \"$docker_name\". Press [Enter]"
		read -p "-> " tmp
		if [ ! "$tmp" = "" ]; then
			docker_name="$tmp"
		fi
		unset tmp

		echo_line "What TAS port for your ${docker_name}? If you want default \"$docker_tas_port\". Press [Enter]"
		read -p "-> " tmp
		if [ ! "$tmp" = "" ]; then
			docker_tas_port="$tmp"
		fi
		unset tmp

		echo_line "What MySql port for your ${docker_name}? If you want default \"$docker_mysql_port\". Press [Enter]"
		read -p "-> " tmp
		if [ ! "$tmp" = "" ]; then
			docker_mysql_port="$tmp"
		fi
		unset tmp

		echo_line "What TAS debug port for your ${docker_name}? If you want default \"$docker_tas_debug\". Press [Enter]"
		read -p "-> " tmp
		if [ ! "$tmp" = "" ]; then
			docker_tas_debug="$tmp"
		fi
		unset tmp
	fi

	refreshDockerCmd
}

function refreshDockerCmd() {
	buildDocker="docker build -t $docker_name $docker_sel_dir"
	runDocker="docker run -d -p $docker_mysql_port:3306 -p $docker_tas_port:6500 -p $docker_tas_debug:6666 -v ~/dev:/root/dev -v $tas_dir:/root/tashome -v ~/.ssh:/root/.ssh -h $docker_name --name $docker_name $docker_name"
	runDocker_mac="docker run -d -p 3306:3306 -p 6500:6500 -p 6666:6666 -v ~/dev:/root/dev -v $tas_dir:/root/tashome -v ~/.ssh:/root/.ssh -h $docker_name --name $docker_name $docker_name"
	execDocker="docker exec -it $docker_name bash"
}


function moveJbossForDocker() {
	selectJboss

	if [  ! -f $docker_sel_dir/$jbossFileName ]; then
		if [ -f $CUR_DIR/$jbossFileName ]; then
			echo_line "Move Jboss from $CUR_DIR to $docker_sel_dir"
			execCmd "sudo mv $CUR_DIR/$jbossFileName $docker_sel_dir"
			echo_line "Move done."
		else
			echo_line "Download Wildfly..."
	    	execCmd "wget -P $docker_sel_dir $jbossUrl"
	    	echo_line "Download Wildfly...Done"
	    fi
	else
		echo_line "Wildfly already Exists."
	fi
}

function moveTasForDocker() {
	selectTas

	if [  ! -f $docker_sel_dir/$tas_ver ]; then
		execCmd "mv ${TMP_DIR}/${tas_ver} ${docker_sel_dir}"
	else
		echo_line "Wildfly already Exists."
	fi
}